/*
Core

Core API is used to manage resources around organisation like auth, set webhooks per channels, manage campaigns.

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package coreapi

import (
	"encoding/json"
)

// checks if the MessageContactIM type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &MessageContactIM{}

// MessageContactIM struct for MessageContactIM
type MessageContactIM struct {
	Service *string `json:"service,omitempty"`
	UserId *string `json:"user_id,omitempty"`
	Type *string `json:"type,omitempty"`
}

// NewMessageContactIM instantiates a new MessageContactIM object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewMessageContactIM() *MessageContactIM {
	this := MessageContactIM{}
	return &this
}

// NewMessageContactIMWithDefaults instantiates a new MessageContactIM object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewMessageContactIMWithDefaults() *MessageContactIM {
	this := MessageContactIM{}
	return &this
}

// GetService returns the Service field value if set, zero value otherwise.
func (o *MessageContactIM) GetService() string {
	if o == nil || IsNil(o.Service) {
		var ret string
		return ret
	}
	return *o.Service
}

// GetServiceOk returns a tuple with the Service field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *MessageContactIM) GetServiceOk() (*string, bool) {
	if o == nil || IsNil(o.Service) {
		return nil, false
	}
	return o.Service, true
}

// HasService returns a boolean if a field has been set.
func (o *MessageContactIM) HasService() bool {
	if o != nil && !IsNil(o.Service) {
		return true
	}

	return false
}

// SetService gets a reference to the given string and assigns it to the Service field.
func (o *MessageContactIM) SetService(v string) {
	o.Service = &v
}

// GetUserId returns the UserId field value if set, zero value otherwise.
func (o *MessageContactIM) GetUserId() string {
	if o == nil || IsNil(o.UserId) {
		var ret string
		return ret
	}
	return *o.UserId
}

// GetUserIdOk returns a tuple with the UserId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *MessageContactIM) GetUserIdOk() (*string, bool) {
	if o == nil || IsNil(o.UserId) {
		return nil, false
	}
	return o.UserId, true
}

// HasUserId returns a boolean if a field has been set.
func (o *MessageContactIM) HasUserId() bool {
	if o != nil && !IsNil(o.UserId) {
		return true
	}

	return false
}

// SetUserId gets a reference to the given string and assigns it to the UserId field.
func (o *MessageContactIM) SetUserId(v string) {
	o.UserId = &v
}

// GetType returns the Type field value if set, zero value otherwise.
func (o *MessageContactIM) GetType() string {
	if o == nil || IsNil(o.Type) {
		var ret string
		return ret
	}
	return *o.Type
}

// GetTypeOk returns a tuple with the Type field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *MessageContactIM) GetTypeOk() (*string, bool) {
	if o == nil || IsNil(o.Type) {
		return nil, false
	}
	return o.Type, true
}

// HasType returns a boolean if a field has been set.
func (o *MessageContactIM) HasType() bool {
	if o != nil && !IsNil(o.Type) {
		return true
	}

	return false
}

// SetType gets a reference to the given string and assigns it to the Type field.
func (o *MessageContactIM) SetType(v string) {
	o.Type = &v
}

func (o MessageContactIM) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o MessageContactIM) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.Service) {
		toSerialize["service"] = o.Service
	}
	if !IsNil(o.UserId) {
		toSerialize["user_id"] = o.UserId
	}
	if !IsNil(o.Type) {
		toSerialize["type"] = o.Type
	}
	return toSerialize, nil
}

type NullableMessageContactIM struct {
	value *MessageContactIM
	isSet bool
}

func (v NullableMessageContactIM) Get() *MessageContactIM {
	return v.value
}

func (v *NullableMessageContactIM) Set(val *MessageContactIM) {
	v.value = val
	v.isSet = true
}

func (v NullableMessageContactIM) IsSet() bool {
	return v.isSet
}

func (v *NullableMessageContactIM) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableMessageContactIM(val *MessageContactIM) *NullableMessageContactIM {
	return &NullableMessageContactIM{value: val, isSet: true}
}

func (v NullableMessageContactIM) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableMessageContactIM) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


